use crate::runtime::{RuntimeError, Value};

pub fn builtin_print(stack: &mut Vec<Value>) -> Result<Value, RuntimeError> {
    print!(
        "{}",
        match stack.pop().ok_or_else(|| RuntimeError {
            message: "expected 1 argument".to_string()
        })? {
            Value::Unit => format!("()"),
            Value::Int(value) => format!("{value}"),
            Value::Float(value) => format!("{value}"),
            Value::String(value) => format!("{value}"),
            Value::Bool(value) => format!("{value}"),
            Value::FunctionReference(addr) => format!("<function reference {addr}>"),
            Value::HeapReference(addr, gen) => format!("<heap reference {addr}, {gen}>"),
        },
    );
    Ok(Value::Unit)
}

pub fn builtin_println(stack: &mut Vec<Value>) -> Result<Value, RuntimeError> {
    builtin_print(stack)?;
    println!("");
    Ok(Value::Unit)
}
